/**
   File name: illegalFormatException.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: class defining a fatal illegal format exception.
   This exception is thrown if the format of the input is somehow
   illegal, the program is exited.
*/

#ifndef _ILLEGAL_FORMAT_H
#define _ILLEGAL_FORMAT_H

static const string _ILLEGAL_MESSAGE = "invalid input format";

/*----------------------- included files ---------------------------*/
#include "exception.h"

class IllegalFormatException: public Exception{
 public:
      /*----------------------- ctor --------------------------------*/

      /*--------------------------------------------------------------
	default ctor
	-------------------------------------------------------------*/
      IllegalFormatException():Exception(_ILLEGAL_MESSAGE){}

      /*--------------------------------------------------------------
	constructs an illegal format exception, which is thrown when
	the format of the input is incorrect.
	-------------------------------------------------------------*/
      IllegalFormatException(const string& message):Exception(message){}
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

