/**
   File name: landingEvent.cpp
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "landingEvent.h"

void LandingEvent::process(Simulation& sim){
      GivatRamSimulation& gsim = dynamic_cast<GivatRamSimulation&> (sim);
      World& world = gsim.getWorld(); 
            
      Entity* ent = world.getEntity(_order);

      if(ent!=0){
	    world.getWind().removeFlyer(_order);
	    
	    Event* birth = 0;
	    PlantFamily* plant = dynamic_cast<PlantFamily*>(ent);
	    try{
		  birth = new BirthEvent(gsim.time()+plant->getFloweringTime(),
					 plant->getOrder());
	    }catch(bad_alloc){
		  delete birth;
		  cerr<<"No available memory."<<endl;
	    }
	    gsim.schedule(birth);
      }
}
