/**
   File name: mapReader.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
   
   File description:
*/

#ifndef _MAP_READER_H
#define _MAP_READER_H

#include <map>
#include <string>
#include <typeinfo>
#include <strstream>

typedef map<string,string> strMap;

class MapReader{
 public:
      MapReader(strMap str):_theParams(str){}
  
      ~MapReader(){}
  
      template <typename T>
	    T getFromMap(const string& param){
    
	    // finding the value that matches the param
	    strMap::const_iterator itr = _theParams.find(param);
	    if(itr == _theParams.end()){
		  throw ReaderException
			("A paramter is missing.");
	    }
    
	    // using the strstream to convert the string into the relevant type
	    strstream stream;
	    stream<<_theParams[param];
    
	    T result;
    
	    // portion for checking if a negative num is given as an
	    // unsigned int - throw illegal format exception
	    T* resultPtr = &result;
	    unsigned int* uintPtr;
    
	    if((typeid(*resultPtr)==typeid(*uintPtr))&&
	       (stream.peek()==_MINUS_SIGN)){
		  throw ReaderException
			("An unsigned int was not given.");
	    }
    
	    // given type int stream doesnt match needed one if null is returned
	    if((stream>>result)==0){
		  throw ReaderException
			("Type doesn't match the given param.");
	    }
    
	    // checking for leftovers in the stream
	    string temp;
	    if(stream>>temp){
		  throw ReaderException
			("A wrong type given.");
	    }
    
	    return result;
      }
  
      unsigned int size()const {return (_theParams.size());}
      
      static const char _MINUS_SIGN;
      
 private:
      strMap _theParams;
  
};

#endif

/*************************************************************************
			       EOF
**************************************************************************/
