/**
   File name: mole.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: This class defines a Mole-Cricket. It inherits
   from the movableEntity class.
   The mole-cricket is defined by its eating time.
*/

#ifndef _MOLE_H
#define _MOLE_H

/*-------------------- included files -----------------------------*/
#include <iostream.h>
#include <string>
#include "movableEntity.h"

class Mole: public MovableEntity{
 public:
      /*----------------- ctor ------------------------------------*/
      /* default ctor. */
      Mole(){}
      /* Constructs a Mole-Cricket with the init of the MovableEntity
       constructor. */
      Mole(unsigned int order, unsigned int xPos,
	   unsigned int yPos, float moveTime,
	   const string movePattern, float eatingTime);

      /*------------- dtor ----------------------------------------*/
      ~Mole(){}

      /*---------------- accessories ------------------------------*/
      /* returns the eating time of the mole-cricket. */
      float getEatingTime()const {return(_eatingTime);}

      /* sets the eating time of the mole-cricket. */
      void setEatingTime(float eatingTime);

      /* returns the string representation of the mole-cricket. */
      virtual ostream& stringFormat(ostream& out)const;

      /* a generic function which defines an encounter between two
	 entities.
       */
      virtual void encounter(Entity* ent, EncounterManager& enc);

      /* encounter between this mole-cricket and a student. */
      virtual void encounterStudent(Student* s, EncounterManager& enc);

      /* encounter between this mole-cricket and a teacher. */
      virtual void encounterTeacher(Teacher* t, EncounterManager& enc);

      /* encounter between this mole-cricket and a flower. */
      virtual void encounterFlower(Flower* f, EncounterManager& enc);

      /* encounter between this mole-cricket and a flower-seed*/
      virtual void encounterSeed(Seed* s, EncounterManager& enc);

      /* encounter between this mole-cricket and a mole-cricket. */
      virtual void encounterMole(Mole* m, EncounterManager& enc);


      // consts denoting the string repres. of the fields of mole-
      // cricket.
      static const string _MOLE;
      static const string _EAT_TIME;
      
 private:
      // const defining the mole-cricket's eating-time
      float _eatingTime;
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

