/**
   File name: movable.cpp
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "movable.h"

Movable::Movable(float moveTime, const string movePattern):
  _moveTime(moveTime), _movePattern(movePattern),
  _randomMove(false),_currentIndex(0){
  if(!Checks<float>::checkStrictlyPositive(_moveTime)||
     (!legalMove(_movePattern))){
    throw IllegalEntityException();
  }
}

void Movable::setMoveTime(float moveTime){
      if(!Checks<float>::checkStrictlyPositive(moveTime))
	    throw IllegalEntityException();
      _moveTime=moveTime;
}

void Movable::setMovePattern(string movePattern){
      if(!legalMove(movePattern))
	    throw IllegalEntityException();
      _movePattern=movePattern;
}

bool Movable::legalMove(string str){
  if(str == _RANDOM){
    _randomMove = true;
    srand(time(NULL)); // initing the random function.
    return true;
  }  

  unsigned int length = str.length();
  char curr;
  for(unsigned int i = 0; i < length; ++i){
    curr = str[i];
    // checking if all chars in the string are directions.
    if(curr!=NORTH && curr!=SOUTH && curr!=WEST && curr!=EAST){
      return false;
    }
  }
  return true;
}

char Movable::getNextDirection(){
  if(_randomMove){    
    unsigned int newDir = rand()%NUM_DIRECTIONS;
    return(_DIRECTIONS[newDir]);
  }
  else{
    if(_currentIndex == _movePattern.length())
      _currentIndex=0;
    return(_movePattern[_currentIndex++]);
  }
}

const Point Movable::getNextLocation(unsigned int x, unsigned int y, char newDir){
  switch(newDir){
  case(NORTH):
    return(Point(x+1, y));
  case(SOUTH):
    return(Point(x-1, y));
  case(EAST):
    return(Point(x, y+1));
  case(WEST):
    return(Point(x, y-1));
  }	
}
		    
const string Movable::_MOVE_TIME = "moving-time";
const string Movable::_MOVE_PAT = "movement-pattern";

const string Movable::_RANDOM = "R";
const char* Movable::_DIRECTIONS = "nsew";
