/**
   File name: movingEvent.cpp
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "movingEvent.h"

void MovingEvent::process(Simulation& sim){
      GivatRamSimulation& gsim = dynamic_cast<GivatRamSimulation&> (sim);
      World& world = gsim.getWorld();
      EncounterManager& manager = gsim.getEncounterManager();
      MovableEntity* ent =
	    dynamic_cast<MovableEntity*>(world.getEntity(_order));

      if(ent!=0){ // entity exists in the data base
	    
	    // reseting the business flag since once a new position is
	    // entered, the entity is no longer busy.
	    ent->setBusiness(false);
	    
	    world.changePoint(ent);
	    gsim.dump(); // world-dump after entity changed its location
	                 
	    world.encounterAll(ent,manager);
	    world.addToPoint(ent);
	    //world.moveAndEncounter(ent,manager);

	    Mole* mole = dynamic_cast<Mole*>(ent);
	    
	    MovingEvent* mevent = 0;
	    try{
	      // if the entity is a mole-cricket, the movement will occur only 
	      // after the mole has eaten. if the mole's isBusy flag is true, 
	      // it is eating
	      if((mole) && (mole->isBusy())){
		float totalTime = mole->getMoveTime()+mole->getEatingTime();
		mevent = 
		  new MovingEvent(gsim.time()+totalTime, mole->getOrder());
	      }
	      else { 
		mevent = 
		  new MovingEvent(gsim.time()+ent->getMoveTime(), ent->getOrder());
	      }
	    }catch(bad_alloc){
	      delete mevent;
	      cerr<<"No memory for the program."<<endl;
	    }

	    gsim.schedule(mevent);
      }     
}
