/**
   File name: parser.cpp
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "parser.h"

strMap Parser::getBlock(){

      // the object which is constructed by default in the map
      strMap::data_type def;

      // the file has ended in the correct foramt.
      if(endOfFile()){
	    throw EndOfInput("File has ended when it should.");
      }

      strMap block;
      string temp;
      try{
	    temp = next(); // typename or first param of world
    
	    block[_FIRST_PARAM] = temp; // the first param in the block 
	    temp = next();

      }catch(IllegalFormatException& ife){
	    if(!_firstRead)
		  throw IllegalParamException("Incorrect params given.");
	    else
		  throw;
      }
      // no opening parentheses, reads first block
      if((temp!=_FIRST_DELIM)&&(!_finishedBlock)){
	    try{  
		  block[_SECOND_PARAM] = temp;
		  block[_THIRD_PARAM] = next();
		  block[_FOURTH_PARAM] = next();
		  block[_FIFTH_PARAM] = next();
		  block[_SIXTH_PARAM] = next();
		  block[_SEVENTH_PARAM] = next();
		  
		  _firstRead = true; // first block has been read
		  _finishedBlock = true; // a block has been read.
		  
	    }catch(IllegalFormatException& ife){
		  if(!_firstRead)
			throw IllegalParamException("Params given are not adequate.");
		  else
			throw; 
	    }
	    
      }
      
      else{ // second string is the { char, move into create entity mode.
	    
	    if(_finishedBlock){
		  
		  _finishedBlock = false;
		  
		  temp = next();
		  
		  // corrupt file, two { chars in a row.
		  if(temp==_FIRST_DELIM){
			throw IllegalFormatException
			      ("Not the right place for { .");
		  }
		  
		  // while the input hasn't ended or the current block
		  while((temp!=_LAST_DELIM)&&(!endOfFile())){
			string param, value;
			param = temp;
			
			temp = next();
			
			// checking that there was an equals sign between
			// the param and its value.
			if(temp!=_EQUALS_SIGN){
			      throw IllegalFormatException
				    ("No equals sign given.");
			}
			
			temp = next();
			
			// checking that the block & file have not ended,
			// plus that another { was not given.
			if((temp==_FIRST_DELIM)||(temp==_LAST_DELIM)||
			   (endOfFile())){
			      throw IllegalFormatException
				    ("File has ended prematurely.");
			}
			value = temp;
			
			// checking if the param already exists in the map
			if(block[param]!=def)
			      throw IllegalFormatException
				    ("Same parameter was given twice.");
			// inserting the param-value pair in the map.
			block[param]=value;

			// advancing the istream
			temp = next();
			if(temp == _LAST_DELIM)
		             _finishedBlock = true;
			
		  }
		  if(temp!=_LAST_DELIM)
			throw IllegalFormatException
			      ("The delim structure is incorrect");
		  
	    }
	    
	    else{ // no opening { was given
		  throw IllegalFormatException
			("You have given incorrect format.");
	    }
      }
      return block;
}

const string Parser::_FIRST_DELIM = "{";
const string Parser::_LAST_DELIM = "}";
const string Parser::_EQUALS_SIGN = "=";
const string Parser::_ROW_DELIM = "#";
const char Parser::_SPACE = ' ';
const char Parser::_NEWLINE = '\n';
const char Parser::_TAB = '\t';
const string Parser::_FIRST_PARAM = "first";
const string Parser::_SECOND_PARAM = "second";
const string Parser::_THIRD_PARAM = "third";
const string Parser::_FOURTH_PARAM = "fourth";
const string Parser::_FIFTH_PARAM = "fifth";
const string Parser::_SIXTH_PARAM = "sixth";
const string Parser::_SEVENTH_PARAM = "seventh";

string Parser::next(){
      
      if(!endOfFile()){
	    string temp;
	    _input>>temp;
	    char c;
	    
	    // searching for the # sign
	    while(temp == _ROW_DELIM){
		 
		  // advancing the string while EOL has not been reached
		  _input.get(c);
		
		  while(c!=_NEWLINE){
			_input.get(c);
		  }
		  
		  if(endOfFile())
			if(_finishedBlock){
			      throw EndOfInput
				    ("The complete block has been read.");
			}
		  
			else
			      throw IllegalFormatException
				    ("Wrong format given!");
		  
		  _input>>temp;
	    }
	    return temp;
      }
      else{
	    throw IllegalFormatException
		  ("File has ended incorrectly.");
      }
}

bool Parser::endOfFile()const{
      char current;

      // deleting all the white spaces
      while (!_input.eof()){
	    current=_input.peek();

	    // a char was found, not a delim
	    if ((current!=_SPACE)&&(current!=_NEWLINE)&&(current!=_TAB))
		  break;

	    // advances the stream
	    _input.get(current);
      }
      return (_input.eof()!=0);
}

/**********************************************************************
				   EOF
***********************************************************************/

