/**
   File name: simulation.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
   
   File description: 
*/

#ifndef _SIMULATION_H
#define _SIMULATION_H


#include "event.h"
#include "eventComparator.h"
#include <queue>
#include <vector>
#include <map>
#include <float.h>


typedef priority_queue<Event*, vector<Event*>, EventComparator> pq;

class Simulation{
 public:
      
  Simulation(){}

  virtual ~Simulation(){}
  
  virtual void init() = 0;
  
  virtual void update() = 0;

  virtual void terminate() = 0;

  void schedule(Event* event){_pq.push(event);}
  
  virtual void run(float from, float to);

  float time()const {return _now;}
  
  static const float MAX_END_TIME;

 protected:
  pq _pq;
  
  float _now;
  
  void runLoop(float from, float to);
    
};
#endif
