/**
   File name: wind.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
   
   File description: This class defines the wind. The wind inherits from the 
   movable class. The wind holds a data-base of all objects it will cause
   to fly. Once directed by the simulation, it will iterate on the DB and 
   cause each object to move.
*/

#ifndef _WIND_H
#define _WIND_H

#include "movable.h"
#include <hash_set>

class Wind: public Movable{
 public:
  typedef hash_set<unsigned int> Set;
  typedef Set::iterator iterator;
  
  Wind(){}
  Wind(float movingTime, const string movingPattern):
    Movable(movingTime, movingPattern){}
  ~Wind(){}
  
  /* adds the order of a new flying entity into the flyers DB */
  void addFlyer(unsigned int order){_flyers.insert(order);}
  
  /* removes the order of a flying entity from the flyers DB*/
  void removeFlyer(unsigned int order){_flyers.erase(order);}
  
  iterator begin() {return _flyers.begin();}
  iterator end() {return _flyers.end();}
  
 private:
  // a set of the orders of all entities which the wind will move
  Set _flyers;
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/
